### Enumeration

# Clutter TouchpadGesturePhase

#### Declaration

    enum Clutter.TouchpadGesturePhase

#### Description [src]

The phase of a touchpad gesture event.

All gestures are guaranteed to begin with an event of type `CLUTTER_TOUCHPAD_GESTURE_PHASE_BEGIN`, followed by a number of `CLUTTER_TOUCHPAD_GESTURE_PHASE_UPDATE` (possibly 0).

A finished gesture may have 2 possible outcomes, an event with phase `CLUTTER_TOUCHPAD_GESTURE_PHASE_END` will be emitted when the gesture is considered successful, this should be used as the hint to perform any permanent changes.

Cancelled gestures may be so for a variety of reasons, due to hardware, or due to the gesture recognition layers hinting the gesture did not finish resolutely (eg. a 3rd finger being added during a pinch gesture). In these cases, the last event with report the phase `CLUTTER_TOUCHPAD_GESTURE_PHASE_CANCEL`, this should be used as a hint to undo any visible/permanent changes that were done throughout the progress of the gesture.

See also `ClutterTouchpadPinchEvent` and `ClutterTouchpadPinchEvent`.4.

#### Members

`CLUTTER_TOUCHPAD_GESTURE_PHASE_BEGIN`

  The gesture has begun.

  - Value: `0`
  - Available since: 14
`CLUTTER_TOUCHPAD_GESTURE_PHASE_UPDATE`

  The gesture has been updated.

  - Value: `1`
  - Available since: 14
`CLUTTER_TOUCHPAD_GESTURE_PHASE_END`

  The gesture was finished, changes should be permanently applied.

  - Value: `2`
  - Available since: 14
`CLUTTER_TOUCHPAD_GESTURE_PHASE_CANCEL`

  The gesture was cancelled, all changes should be undone.

  - Value: `3`
  - Available since: 14